

module Irensei

#
#_
#
EMPTY=0

#
#
#
BLACK=1

#
#
#
WHITE=2

#
#ՊO
#
OUT_OF_BOARD=3


#
#WNX(pX܂)
#x=-1,y=-1̓pX\B
#
class Point

	#
	#xW
	#
	attr_reader :x
	
	#
	#yW
	#
	attr_reader :y
	
	#
	#B
	#
	def initialize(x,y)
		@x=x
		@y=y
	end
	
	#
	#肪pXB
	#
	def isPass
		return @x==-1 && @y==-1
	end
	
	#
	#̍W̗אړ_i㉺EjB
	#
	def neighbor4
		[
			Point.new(@x+1,@y),
			Point.new(@x-1,@y),
			Point.new(@x,@y+1),
			Point.new(@x,@y-1)
		]
	end
	
	#
	#̍W̗אړ_ijB
	#
	def neighbor8
		neighbor4+
		[
			Point.new(@x+1,@y+1),
			Point.new(@x+1,@y-1),
			Point.new(@x-1,@y+1),
			Point.new(@x-1,@y-1)
		]
	end
	
	#
	#̍W̗אړ_ijƈԔт̓_B
	#
	def neighbor12
		neighbor8+
		[
			Point.new(@x+2,@y),
			Point.new(@x-2,@y),
			Point.new(@x,@y+2),
			Point.new(@x,@y-2)
		]
	end
	
	#
	#WSGF`ɂƂ̕B
	#
	def to_SGF
		if isPass
		then
			""
		else
			"%c%c" % [("a"[0]+@x),("a"[0]+@y)]
		end
	end
	
	#
	#񉻁B
	#
	def to_s
		"("+@x.to_s+","+@y.to_s+")"
	end
	
	def +(point)
		Point.new(@x+point.x,@y+point.y)
	end

	def -(point)
		Point.new(@x-point.x,@y-point.y)
	end
	
	def == (point)
		@x==point.x && @y == point.y
	end
	
	def <=> (point)
		return @x-point.x unless @x == point.x 
		return @y-point.y 
	end
end


#
#͘A
#
class Board

	#
	# HՂ\(Fixnum)B
	#
	attr_reader :size
	
	#
	#Տɓ_邩(Fixnum)B
	#
	attr_reader :point_num
	
	#
	#Ղ̃TCY͈̔(Range)
	#
	attr_reader :range
	
	#
	#Տ̑SĂ̓_(Array)
	#
	attr_reader :all_point
	
	#
	#(Point)
	#
	attr_accessor :kou_point
	
	#
	#(Fixnum)
	#
	attr_accessor :turn
	
	#
	#Bɂ͉HՂł邩Fixnum^
	#
	def initialize(size)
		@size=size
		@point_num=size*size
		@table=[EMPTY]*@point_num
		@range=0...size
		@all_point=[]
		@range.each{|y|
			@range.each{|x| 
				@all_point << Point.new(x,y)
			}
		}
		@kou_point = nil
		@turn = BLACK
		extend Rule9ro if size == 9
	end
	
	#
	#̎
	#
	def opponent(stone)
		case stone
		when BLACK : WHITE
		when WHITE : BLACK
		else      
			OUT_OF_BOARD
		end
	end

	def size=(s)
		@size=s
	end
	
	
	def point_num=(p)
		@point_num=p
	end
	
	def table=(t)
		@table=t
	end
	
	def range=(r)
		@range=r
	end
	
	def all_point=(a)
		@all_point=a
	end
	
	def table
		@table
	end
	
	protected :size=
	protected :point_num=
	protected :table=
	protected :range=
	protected :all_point=
	protected :table


	#
	#Rs[
	#
	def dup
		result=Board.new(@size)
		result.size=@size
		result.point_num=@point_num
		result.range=@range
		result.all_point=@all_point
		result.kou_point=@kou_point
		result.turn=@turn
		result.table=@table.dup
		result
	end
	
	#
	#WՊOłȂǂBɂ͍W(Point)n
	#
	def inBoard?(point)
		@range.include?(point.x) && @range.include?(point.y)
	end
	
	#
	#WŎĂz̃CfbNXւ̕ϊ
	#
	def point_to_i(point)
		point.x+point.y*@size
	end

	#
	#̍W̐΂̐F擾Bɂ͍W(Point)n
	#
	def getStone(point)	
		return OUT_OF_BOARD unless inBoard?(point)
		return @table[point_to_i(point)]
	end
	
	#
	#̍Wɐ΂uB͘Ã[͓KpȂB
	#ɂ͍W(Point)Ɛ΂̐F(Fixnum)^B
	#߂l͍XV͘AՎg
	#
	def setStone(point,stone)
		@table[point_to_i(point)]=stone if inBoard?(point)
		self
	end
	
	#
	#̍Wɓ΂uB͘Ã[͓KpȂB
	#ɂ͗vfPointEnumerableȃIuWFNgiArrayȂ)Ɛ΂̐F(Fixnum)^B
	#
	def setStones(point_set,stone)
		point_set.each{|point|
			setStone(point,stone)
		}
		self
	end
	
	def == (board)
		board.table == @table && board.kou_point == @kou_point && board.turn == @turn
	end
	
	#
	#Ֆʃf[^\z𒼐ڐݒ肷B
	#gp
	#
	#board=Board.new(9)
	#ary=[ 
	#      0,0,0,0,0,0,0,0,0,
	#      0,0,0,0,0,0,0,0,0,
	#      0,0,0,0,0,1,2,0,0,
	#      0,0,0,0,2,1,0,0,0,
	#      0,0,0,0,1,0,0,0,0,
	#      0,0,0,0,0,2,0,0,0,
	#      0,0,0,0,0,0,0,0,0,
	#      0,0,0,0,0,0,0,0,0,
	#      0,0,0,0,0,0,0,0,0]
	#board.setBoard(ary)
	#
	def setBoard(ary)
		@table=ary
		self
	end

	#
	#
	#
	def to_s
		result=""
		range.each {|y|
			range.each {|x| 
				result=result +
				case getStone(Point.new(x,y))
				when EMPTY : 
				    if @kou_point && Point.new(x,y) == @kou_point     then "~"
					elsif x == 0       && y == 0        then ""
					elsif x == 0       && y == @size-1  then ""
					elsif x == @size-1 && y == 0        then  ""
					elsif x == @size-1 && y == @size-1  then  ""
					elsif x == 0                        then ""
					elsif x == @size-1                  then ""
					elsif y == 0                        then ""
					elsif y == @size-1                  then ""
					else                                     ""
					end
				when BLACK : ""
				when WHITE : ""
				when OUT_OF_BOARD : ""
				else
					getStone(Point.new(x,y)).to_s
				end
			}
			result = result + "\n"
		}
		result
	end
end


#
#A΁BiłグƂ̒PʂƂȂ΂̉jB
#
class StoneSet
	#
	#΂̍W̏W(PointArray)
	#
	attr_reader :stone_set

	#
	#ċz_̏W(PointArray)
	#
	attr_reader :dame

	#
	#΂̐F(Fixnum)
	#
	attr_reader :stone
	
	#
	#HՂ
	#
	attr_reader :size
	
	#
	#
	#
	def initialize
		@stone_set = []
		@dame = []
		@stone = EMPTY
		@size = 0
	end
	
	#
	#A΂̃f[^쐬B
	#ɂBoardPoint^B
	#Pointɒuꂽ΂܂ޘA΂̏W̃f[^𓾂B
	#
	def make(board,point)
		@stone = board.getStone(point)
		@size = board.size
		if(@stone == BLACK || @stone == WHITE )
		then
			search(board,point)
		end
		self
	end

	def search(board,point)
		case board.getStone(point)
		when @stone
			unless @stone_set.include?(point)
			then
				@stone_set << point
				point.neighbor4.each{|p|
					search(board,p)
				}
			end
		when EMPTY
			@dame << point unless @dame.include?(point)
		end
	end

	protected :search

	#
	#
	#
	def to_s
		tmp=Board.new(@size)
		@stone_set.each{|p|
			tmp.setStone(p,@stone)
		}
		@dame.each{|p|
			tmp.setStone(p,"E")
		}
		tmp.to_s
	end
end

#
#9HՂ̈͘A[
#BoardNXextendĎgB
#
module Rule9ro

	#
	#isɌēF̐΂AŒuĂ邩B
	#stone͐΂̐F(Fixnum),point͒TJnʒu(Point),direction͐is(Point)
	#
	def straight(stone,point,direction)
		return straight(stone,point+direction,direction)+1 if getStone(point)==stone
		return 0
	end

	#
	#^ꂽ_܂ޘAōłA̒B
	#ɂstone͐΂̐F(Fixnum),point͒T̊Jn_B
	#tyouren͒A̗L̒TĂ̂ǂ(Boolean)B
	#ł7A̗LTꍇtyouren=falseA
	#ł钷A̗LTꍇtyouren=truew肷B
	#
	def maxStraight(stone,point,tyouren)
		max=0
		
		if tyouren ||  (point.y != 0 && point.y != @size-1)
		then
			result = straight(stone,point+Point.new(1,0),Point.new(1,0))+
			         straight(stone,point+Point.new(-1,0),Point.new(-1,0))+1
			max = result if max < result
		end
		
		if tyouren || (point.x != 0 && point.x != @size-1)
		then
			result = straight(stone,point+Point.new(0,1),Point.new(0,1))+
			         straight(stone,point+Point.new(0,-1),Point.new(0,-1))+1
			max = result if max < result
		end
		
		result = straight(stone,point+Point.new(1,1),Point.new(1,1))+
		         straight(stone,point+Point.new(-1,-1),Point.new(-1,-1))+1
		max = result if max < result
		
		result = straight(stone,point+Point.new(-1,1),Point.new(-1,1))+
				 straight(stone,point+Point.new(1,-1),Point.new(1,-1))+1
		max = result if max < result
		max
	end


	#
	#Ԃ̃v[[̍Wɒ肵Ƃ7A邩H
	#ɂ͒̍W(Point)^B
	#
	def is7ren?(point)
		max = maxStraight(@turn,point,false)
		(@turn == BLACK && max == 7 ) || (@turn == WHITE && max >=7)
	end

	#
	#Ԃ̃v[[̍Wɒ肵ƂAɂȂĂ܂H
	#ɂ͒̍W(Point)^B
	#
	def isTyouren?(point)
		@turn == BLACK && maxStraight(@turn,point,true) >7
	end


	#
	#Ԃ̃v[[̍Wɒ肷͍̂@肩H
	#ɂ͒̍W(Point)^B
	#
	def validMove?(point)
		return false if getStone(point)!=EMPTY
		return false if isTyouren?(point)	
		return true  if is7ren?(point)
		return true if point.neighbor4.collect{|p| getStone(p)}.include?(EMPTY)
		
		around_stone_set=point.neighbor4.collect{|p| StoneSet.new.make(self,p)}
		
		return true if around_stone_set.any? {|s| s.stone == @turn && s.dame.size >=2 }
		
		capture_stone_num = around_stone_set.inject(0){|result,s| 
			result + ((s.stone == opponent(@turn) && s.dame.size == 1 ) ? s.stone_set.size : 0 )
		}
		
		return true if capture_stone_num >=2 || (capture_stone_num == 1 && @kou_point != point)
		return false
		
	end

	#
	#Ԃ̃v[[肵Ƃ̔Ֆ(Board)ԂB
	#ɂ͒̍W(Point)^B
	#̊֐ĂяoĂĂяoIuWFNg͕ωȂB
	#
	def play(point)
		result=self.dup
		
		if point.isPass
		then 
			result.turn=opponent(result.turn)
			result.kou_point = nil
			return result
		end
		
		return result unless result.validMove?(point)

		result.setStone(point,result.turn)
		captured_stone_set=point.neighbor4.collect{|p| StoneSet.new.make(result,p)}.find_all{|s| s.stone == opponent(result.turn) && s.dame.size == 0 }
		
		captured_stone_set.each {|s| result.setStones(s.stone_set,EMPTY)}
		result.kou_point = (captured_stone_set.inject(0) {|res,s| res + s.stone_set.size } == 1) ? captured_stone_set[0].stone_set[0] : nil
		result.turn=opponent(result.turn)
		result
	end

	#
	#Ԃ̃v[[肵Ƃ̔ՖʂɂB
	#ɂ͒̍W(Point)^B
	#̊֐͔jIȃ\bhłB
	#
	def play!(point)
	
		if point.isPass
		then 
			@turn=opponent(@turn)
			@kou_point = nil
			return self
		end
		
		return self unless validMove?(point)

		setStone(point,@turn)
		captured_stone_set=point.neighbor4.collect{|p| StoneSet.new.make(self,p)}.find_all{|s| s.stone == opponent(@turn) && s.dame.size == 0 }
		
		captured_stone_set.each {|s| setStones(s.stone_set,EMPTY)}
		@kou_point = (captured_stone_set.inject(0) {|res,s| res + s.stone_set.size } == 1) ? captured_stone_set[0].stone_set[0] : nil
		@turn=opponent(@turn)
		self
	end
end

#
#͘ÃQ[
#
class Game

	#
	#HՂ
	#
	attr_reader :size

	#
	#B
	#ɂ͉HՂ(Fixnum)^
	#
	def initialize(size)
		@size=size
		#
		#Ֆʂ̗
		#
		@history=[]
		@history_point=[]
		@history[0]=Board.new(size)
	end

	#
	#ŏI_
	#
	def last_move
		@history_point.last
	end
	
	#
	#݂̔Ֆ
	#
	def board
		@history.last
	end
	
	#
	#݂̔Ֆʂɑ΂̒肪@肩ǂH
	# ɂ͒̍W(Point)^B
	#
	def validMove?(point)
		board.validMove?(point)
	end

	#
	#Ԃ̃v[[肷B
	# ɂ͒̍W(Point)^B
	# ߂l͂̒̌ʂԂB
	# :DRAW 
	# :PASS pX
	# :BLACK_WIN Ԃ̏
	# :WHITE_WIN Ԃ̏
	# :INVALID_MOVE  񍇖@
	# :CONTINUE  Q[s
	#
	def play(point)
		if last_move and last_move.isPass and point.isPass
			@history_point<< point
			@history << board.play(point)
			return :DRAW
		end
		
		if point.isPass
			@history_point<< point
			@history << board.play(point)
			return :PASS
		end
		
		return :INVALID_MOVE unless validMove?(point)
		
		@history_point<< point
	
		b=board
	
		@history << (board.play(point))
		
		if b.is7ren?(point)
		then
			return :BLACK_WIN if b.turn == BLACK
			return :WHITE_WIN if b.turn == WHITE
		end
		
		return :CONTINUE
	end
	
	#
	#Ԃɖ߂
	#
	def clear
		@history.clear
		@history[0]=Board.new(@size)
		@history_point.clear
	end

	#
	#҂
	#
	def undo
		@history.pop if @history.size >1
		@history_point.pop if @history_point.size>0
	end
	
	#
	#
	#
	def to_s
		board.to_s
	end
	
	#
	#SGF`̃f[^𕶎ŕԂ
	#
	def getSGF
		result="(\n"
		result+=";FF[1]GM[1]SZ[%d]\n"%@size
		@history_point.each_with_index{|point,index|
			if index%2==0
			then
				if point.isPass
				then
					result+=";B[]"
				else
					result+=";B["+point.to_SGF+"]"
				end
			else
				result+=";W["+point.to_SGF+"]"
			end
			if index % 6 == 5
			then
				result+="\n"
			end
		}
		result+=")\n"
	end
		
	
end 

end



