require "tk"
require "Irensei"

include Irensei


srand

ai_list=["Human"]

Dir.open('.').each{|ai|
	if(/^ai/=~ai)
	then
		require './'+ai
		ai_list << File.basename(ai.capitalize,".*")
	end
}


@@board_size=9
@@size=30

@@cspan=5

@@on_game=false

@@ai_black=nil
@@ai_white=nil

root=TkRoot.new{title "͘A"}


def clear_ai
	@@ai_black.clear if @@ai_black
	@@ai_white.clear if @@ai_white
end


TkButton.new(root){
	text "New Game"
	command{
			clear_ai
			@@game.clear
			@@canvas.draw_board
			Tk.update
	
			@@ai_black=((@@black_ai_name.text=="Human")?nil:Object.const_get(@@black_ai_name.text)::AI.new(BLACK));
			@@ai_white=((@@white_ai_name.text=="Human")?nil:Object.const_get(@@white_ai_name.text)::AI.new(WHITE));
			
			if @@ai_black && @@ai_white
			then
				ai=@@ai_black
				play_array=@@ai_black.play
				play_point=Point.new(play_array[0],play_array[1])
				@@game.play(play_point)
				@@canvas.draw_board
				Tk.update
				while true
					ai_opponent=ai
					ai=((ai==@@ai_black)?@@ai_white:@@ai_black)
					turn=((ai==@@ai_black)?'Black':'White')
					ai.input_opponent_player_move(play_point.x,play_point.y)
					play_array=ai.play
					play_point=Point.new(play_array[0],play_array[1])
					res=@@game.play(play_point)
					@@canvas.draw_board
					Tk.update
					case res
					when :BLACK_WIN then
						Tk.messageBox('message'=>'Black win!')
						ai_opponent.input_opponent_player_move(play_point.x,play_point.y)
						clear_ai
						return
					when :WHITE_WIN then
						Tk.messageBox('message'=>'White win!')
						ai_opponent.input_opponent_player_move(play_point.x,play_point.y)
						clear_ai
						return
					when :INVALID_MOVE then
						Tk.messageBox('message'=>(turn + ' invaild move!'))
						ai_opponent.input_opponent_player_move(play_point.x,play_point.y)
						clear_ai
						return
					when :DRAW
						Tk.messageBox('message'=>'Draw!')
						ai_opponent.input_opponent_player_move(play_point.x,play_point.y)
						clear_ai
						return
					end		
				end
			end
			if @@ai_black
				ai=@@ai_black
				play_array=ai.play
				play_point2=Point.new(play_array[0],play_array[1])
				@@game.play(play_point2);
				@@canvas.draw_board
				Tk.update

			end
			@@on_game=true
			@@canvas.draw_board;
			Tk.update
	}
	grid('row'=>3,'column'=>1)
}

TkButton.new(root){
	text('SGF File')
	command{
		open("result.sgf","w") do |output|
			output.print @@game.getSGF
		end
	}
	grid('row'=>3,'column'=>5)
}

TkButton.new(root){
	text('pass')
	command{
		if @@on_game
			pass_point=Point.new(-1,-1)
			res=@@game.play(pass_point)
			@@canvas.draw_board
			Tk.update

			if res == :DRAW
			then
				Tk.messageBox('message'=>'Draw!')
				@@on_game=false
				return
			end
		
			return if  not @@ai_black and not @@ai_white 
		
			ai=(@@ai_black ? @@ai_black : @@ai_white)
		
			ai.input_opponent_player_move(-1,-1)
			play_array=ai.play
			play_point2=Point.new(play_array[0],play_array[1])
		
			res2=@@game.play(play_point2);
			@@canvas.draw_board
			Tk.update

			case res2
			when :BLACK_WIN then
				Tk.messageBox('message'=>'Black win!')
				@@on_game=false
				clear_ai
				return
			when :WHITE_WIN then
				Tk.messageBox('message'=>'White win!')
				@@on_game=false
				clear_ai
				return 
			when :INVALID_MOVE then
				Tk.messageBox('message'=>'Computer invalid move!')
				@@on_game=false
				clear_ai

				return
			when :DRAW
				Tk.messageBox('message'=>'Computer pass!')
				Tk.messageBox('message'=>'Draw')
				@@on_game=false
				clear_ai
				return
			end
		end
	}
	grid('row'=>3,'column'=>6)
}


@@black_label=TkLabel.new(root){text('');grid('row'=>0,'column'=>1,'columnspan'=>@@cspan)}
@@white_label=TkLabel.new(root){text('');grid('row'=>0,'column'=>@@cspan+1,'columnspan'=>@@cspan)}


@@black_ai_name=TkLabel.new(root){text('Human');grid('row'=>1,'column'=>1,'columnspan'=>@@cspan)}
@@white_ai_name=TkLabel.new(root){text('Human');grid('row'=>1,'column'=>@@cspan+1,'columnspan'=>@@cspan)}


@@black_list_box=TkListbox.new(root){grid('row'=>2,'column'=>1,'columnspan'=>@@cspan,'sticky'=>'n')}
ai_list.each{|ai|
	@@black_list_box.insert('end',ai)
}

@@black_list_box.bind('ButtonRelease-1',proc{ @@black_ai_name.text(@@black_list_box.get(@@black_list_box.curselection))})

@@white_list_box=TkListbox.new(root){grid('row'=>2,'column'=>@@cspan+1,'columnspan'=>@@cspan,'sticky'=>'n')}
ai_list.each{|ai|
	@@white_list_box.insert('end',ai)
}

@@white_list_box.bind('ButtonRelease-1',proc{ @@white_ai_name.text(@@white_list_box.get(@@white_list_box.curselection))})

@@game=Game.new(@@board_size)


@@cpu_label=TkLabel.new(root){
	text("CPU")
	grid('row'=>10,'column'=>1,'sticky'=>'n')
}

@@cpu_prog=TkCanvas.new(root) {
	width(220)
	height(30)
	
	def draw_cpu_prog(parsent)
		if (0..100).include?(parsent)
		then 
			TkcRectangle.new(self,10,10,200,15,"fill"=>"blue","outline"=>"blue")
			TkcRectangle.new(self,10,10,2*parsent,15,"fill"=>"red","outline"=>"red") unless parsent == 0
		end
	end
	
	draw_cpu_prog 0
	Tk.update
	
	grid('row'=>10,'column'=>2,'columnspan'=>@@cspan*5,'sticky'=>'n')
}


@@canvas=TkCanvas.new(root) {
	width((@@board_size+3)*@@size)
	height((@@board_size+3)*@@size)
	
	def draw_board
		TkcRectangle.new(self,@@size,@@size,(@@board_size+2)*@@size,(@@board_size+2)*@@size,"fill"=>"yellow","outline"=>"black")

		for x in 1..@@board_size
			TkcLine.new(self,(x+1)*@@size,@@size*2,(x+1)*@@size,@@size*(@@board_size+1)){ fill "black" }
		end

		for y in 1..@@board_size
			TkcLine.new(self,@@size*2,(y+1)*@@size,@@size*(@@board_size+1),(y+1)*@@size){ fill "black"}
		end

		for x in 0..@@board_size
			for y in 0..@@board_size
				case @@game.board.getStone(Point.new(x,y))
				when BLACK : TkcOval.new(self,@@size*(x+1.5),@@size*(y+1.5),@@size*(x+2.5),@@size*(y+2.5)){ fill "black"}
				when WHITE : TkcOval.new(self,@@size*(x+1.5),@@size*(y+1.5),@@size*(x+2.5),@@size*(y+2.5)){ fill "white"}
				end
			end
		end
		
		if @@game.last_move && !@@game.last_move.isPass
		then
			x=@@game.last_move.x
			y=@@game.last_move.y
			case @@game.board.getStone(Point.new(x,y))
			when BLACK : TkcOval.new(self,@@size*(x+1.8),@@size*(y+1.8),@@size*(x+2.2),@@size*(y+2.2)){ fill "white"}
			when WHITE : TkcOval.new(self,@@size*(x+1.8),@@size*(y+1.8),@@size*(x+2.2),@@size*(y+2.2)){ fill "black"}
			end
		end
		
	end
	
	
	bind 'Button' , proc { |x,y|
		return unless @@on_game

		ai=(@@ai_black ? @@ai_black : @@ai_white)
		
		play_point=Point.new(((x+@@size/2)/@@size)-2,((y+@@size/2)/@@size)-2)
		res=@@game.play(play_point);
		draw_board
		Tk.update
		
		case res
		when :BLACK_WIN then
			ai.input_opponent_player_move(play_point.x,play_point.y)
			Tk.messageBox('message'=>'Black win!')
			draw_board
			Tk.update
			@@on_game=false
			return
		when :WHITE_WIN then
			ai.input_opponent_player_move(play_point.x,play_point.y)
			Tk.messageBox('message'=>'White win!')
			draw_board
			Tk.update
			@@on_game=false

			return
		when :INVALID_MOVE then
			Tk.messageBox('message'=>'Invalid move!')
			draw_board
			Tk.update
#			ai.input_opponent_player_move(play_point.x,play_point.y)
			return
		end

		return if  not @@ai_black and not @@ai_white 
		
		ai.input_opponent_player_move(play_point.x,play_point.y)
		play_array=ai.play
		play_point2=Point.new(play_array[0],play_array[1])
		
		res2=@@game.play(play_point2);
		draw_board
		Tk.update

		case res2
		when :BLACK_WIN then
			Tk.messageBox('message'=>'Black win!')
			@@on_game=false
			return
		when :WHITE_WIN then
			Tk.messageBox('message'=>'White win!')
			@@on_game=false
			return 
		when :INVALID_MOVE then
			Tk.messageBox('message'=>'Computer invalid move!')
			@@on_game=false
			return
		when :DRAW
			Tk.messageBox('message'=>'Computer pass!')
			Tk.messaeBox('message'=>'Draw!')
			@@on_game=false
			return
		when :PASS
			Tk.messageBox('message'=>'Computer pass!')
			return
		end
			
	},"%x %y"
	
	draw_board
	Tk.update

	grid('row'=>0,'column'=>0,'rowspan'=>20)
}


exit if defined?(REQUIRE2LIB)
Tk.mainloop

clear_ai
